nginx+unicornでrails

サブディレクトリごとに複数アプリを配置するやり方

ひとつ目のアプリをapp1とし、/var/www/app1/に置かれているものとする。webブラウザで見ると、hoge.com/にapp2、hoge.com/app1/にapp1があるように見えるようにする。

設定するファイルは/etc/nginx/conf.d/local.conf、 /var/www/app1/script/unicorn.sh(新規)、/var/www/app1/config.ru、/var/www/app1/config/unicorn.rb(新規)、app2用のunicorn.sh、config.ru、unicorn.rb。

流れとしては

  1. script/unicorn.shでunicornを起動し、この時にpathをオプションで指定する。unicorn.rbはこの起動に必要。
  2. config.ruがpathを受け取って、内部でのパスの構成をうまくやってくれる。
  3. nginx/conf.d/local.confでnginxがリクエスを受けた時の処理を記述する。

script/unicorn.sh

パクってきたものを改造して使う。ポイントはオプション--pathを使うこと、unicornではなく、unicorn_railsを使うこと。unicornだと--pathオプションが使えないっぽい。この2つの違いは、ここに書いてあった。別にどこに置いてもいいはずだが、みんながそうしているからscriptというディレクトリを作ってそこに置いた。

#!/bin/bash

set -e

TIMEOUT=${TIMEOUT-60}
APP_ROOT=$PWD
PID="$APP_ROOT/tmp/unicorn.pid"
RAILS_ENV=production
#RAILS_ENV=development
CMD="bundle exec unicorn_rails -D --path /${APP_ROOT##*/} -c $APP_ROOT/config/$
#CMD="bundle exec unicorn -D -c $APP_ROOT/config/unicorn.rb -E $RAILS_ENV"
action="$1"
set -u


old_pid="$PID.oldbin"

cd $APP_ROOT || exit 1

sig () {
    test -s "$PID" && kill -$1 `cat $PID`
}

oldsig () {
    test -s $old_pid && kill -$1 `cat $old_pid`
}

case $action in
start)
    sig 0 && echo >&2 "Already running" && exit 0
    $CMD
    ;;
stop)
    sig QUIT && rm -f ${PID} && exit 0
    echo >&2 "Not running"
    ;;
force-stop)
    sig TERM && exit 0
    echo >&2 "Not running"
    ;;

restart|reload)
    sig HUP && echo reloaded OK && exit 0
    echo >&2 "Couldn't reload, starting '$CMD' instead"
    $CMD
    ;;
upgrade)
    if sig USR2 && sleep 2 && sig 0 && oldsig QUIT
    then
        n=$TIMEOUT
        while test -s $old_pid && test $n -ge 0
        do
            printf '.' && sleep 1 && n=$(( $n - 1 ))
        done
        echo

        if test $n -lt 0 && test -s $old_pid
        then
            echo >&2 "$old_pid still exists after $TIMEOUT seconds"
            exit 1
        fi
        exit 0
    fi
    echo >&2 "Couldn't upgrade, starting '$CMD' instead"
    $CMD
    ;;
reopen-logs)
    sig USR1
    ;;
*)
    echo >&2 "Usage: $0 "
    exit 1
    ;;
esac

config/unicorn.rb

パクってきたものをそのまま使う。

# -*- coding: utf-8 -*-
worker_processes 2

listen  Dir.pwd + '/tmp/unicorn.sock'
pid     Dir.pwd + '/tmp/unicorn.pid'

log = Dir.pwd + '/log/unicorn.log'
stderr_path File.expand_path('log/unicorn.log', ENV['RAILS_ROOT'])
stdout_path File.expand_path('log/unicorn.log', ENV['RAILS_ROOT'])

preload_app true
GC.respond_to?(:copy_on_write_friendly=) and GC.copy_on_write_friendly = true

before_fork do |server, worker|
defined?(ActiveRecord::Base) and ActiveRecord::Base.connection.disconnect!

old_pid = "#{ server.config[:pid] }.oldbin"
unless old_pid == server.pid
  begin
   sig = (worker.nr + 1) >= server.worker_processes ? :QUIT : :TTOU
   Process.kill :QUIT, File.read(old_pid).to_i
   rescue Errno::ENOENT, Errno::ESRCH
  end
end
end

after_fork do |server, worker|
    defined?(ActiveRecord::Base) and ActiveRecord::Base.establish_connection
end

config.ru

require ::File.expand_path('../config/environment', __FILE__)
if ENV['RAILS_RELATIVE_URL_ROOT']
  map ENV['RAILS_RELATIVE_URL_ROOT'] do
    run Rails.application
  end
else
  run Rails.application
end

/etc/nginx/conf.d/local.conf

upstream app1 {
  server unix:/var/www/app1/tmp/unicorn.sock;
}

upstream app2{
  server unix:/var/www/app2/tmp/unicorn.sock;
}

server {
  listen 80 default_server;
  server_name ik1-330-25055.vs.sakura.ne.jp;
  access_log /var/log/nginx/access.log;
  error_log /var/log/nginx/error.log;

  client_max_body_size 100m;
  error_page 404 /404.html;
  error_page 500 502 503 504 /500.html;

  location /app1 {
    alias /var/www/app1/public;
    try_files $uri/index.html $uri @app1;
  }
  location ~ ^/app1/assets/(.*) {
    alias /var/www/app1/public/assets/$1;
  }

  location / {
    alias /var/www/app2/public;
    try_files $uri/index.html $uri @app2;
  }
  location ~ ^/assets/(.*) {
    alias /var/www/app2/public/assets/$1;
  }

  location @app1 {
    proxy_set_header X-Real-IP $remote_addr;
    proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
    proxy_set_header Host $http_host;
    proxy_pass http://app1;
  }

  location @app2 {
    proxy_set_header X-Real-IP $remote_addr;
    proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
    proxy_set_header Host $http_host;
    proxy_pass http://app2;
  }
}

参考

  • http://unlearned.hatenablog.com/entry/2014/02/28/015554
  • http://qiita.com/noppefoxwolf/items/e1e5a5ab221f8224890d
  • http://qiita.com/iriya-ufo@github/items/0c2122550e69d9b0aff6